leetcode376. Wiggle Subsequence

栏目: 编程工具 · 发布时间: 5年前

内容简介:扭动序列是指数组中的相邻两个元素的差保证严格的正负交替,如这是一个可以通过动态规划来解决的问题。动态规划的特点就是,加入我知道第i个元素的结果,那么第i+1个元素的结果可以由其推到出来。这里假设我们知道,以第i个元素为止的最长子序列长度,包括上升序列up和下降序列down,则第i+1个元素的可能情况如下:代码如下:

题目要求

A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.

For example, [1,7,4,9,2,5] is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast, [1,4,7,2,5] and [1,7,4,5,5] are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.

Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.

Example 1:

Input: [1,7,4,9,2,5]
Output: 6
Explanation: The entire sequence is a wiggle sequence.
Example 2:

Input: [1,17,5,10,13,15,10,5,16,8]
Output: 7
Explanation: There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8].
Example 3:

Input: [1,2,3,4,5,6,7,8,9]
Output: 2
Follow up:
Can you do it in O(n) time?

扭动序列是指数组中的相邻两个元素的差保证严格的正负交替,如 [1,7,4,9,2,5] 数组中相邻两个元素的差为 6,-3,5,-7,3 ,满足扭动序列的要求。现在要求从一个数组中,找到长度最长的扭动子序列,并返回其长度。

思路和代码

这是一个可以通过动态规划来解决的问题。动态规划的特点就是,加入我知道第i个元素的结果,那么第i+1个元素的结果可以由其推到出来。这里假设我们知道,以第i个元素为止的最长子序列长度,包括上升序列up和下降序列down,则第i+1个元素的可能情况如下:

  • nums[i+1]>nums[i] : 即前一个元素和当前元素构成上升序列,因此 up[i+1]=down[i]+1, down[i+1]=down[i] ,这是指以第i个元素为结尾的上升序列应当基于第i-1个元素为结尾的下降序列,而以第i个元素为结尾的下降序列,等同于基于第i-1个元素为结尾的下降序列。
  • nums[i+1]>nums[i] : 即前一个元素和当前元素构成下降序列,因此 down[i+1]=up[i]+1, up[i+1]=up[i]
  • nums[i+1]=nums[i] : down[i+1]=down[i], up[i+1]=up[i]

代码如下:

public int wiggleMaxLength(int[] nums) {
        if( nums.length == 0 ) return 0;
        int[] up = new int[nums.length];
        int[] down = new int[nums.length];
        up[0] = 1;
        down[0] = 1;
        for(int i = 1 ; i<nums.length ; i++) {
            if(nums[i] > nums[i-1]) {
                up[i] = down[i-1] + 1;
                down[i] = down[i-1];
            }else if(nums[i] < nums[i-1]) {
                down[i] = up[i-1] + 1;
                up[i] = up[i-1];
            }else {
                down[i] = down[i-1];
                up[i] = up[i-1];
            }
        }
        return Math.max(up[nums.length-1], down[nums.length-1]);
    }

以上所述就是小编给大家介绍的《leetcode376. Wiggle Subsequence》,希望对大家有所帮助,如果大家有任何疑问请给我留言,小编会及时回复大家的。在此也非常感谢大家对 码农网 的支持!

查看所有标签

猜你喜欢:

本站部分资源来源于网络,本站转载出于传递更多信息之目的,版权归原作者或者来源机构所有,如转载稿涉及版权问题,请联系我们

编程风格

编程风格

[美] Cristina Videira Lopes / 顾中磊 / 人民邮电出版社 / 2017-8 / 55.00元

本书对一个常见的编程问题定义了不同的约束,分别使用33种方法实现了同一个词频统计任务,从而形成了风格迥异的编程风格。作者以惯用的计算机语言与简单的任务为画笔,描绘了一次生动难忘的编程之旅,帮助读者加深了对语言的理解,也提供了崭新的编程思路。一起来看看 《编程风格》 这本书的介绍吧!

JSON 在线解析
JSON 在线解析

在线 JSON 格式化工具

RGB转16进制工具
RGB转16进制工具

RGB HEX 互转工具

HTML 编码/解码
HTML 编码/解码

HTML 编码/解码